#include "stdafx.h"
#include "MainForm.h"

using namespace TestTool;

// RXgN^
MainForm::MainForm( void )
{
    InitializeComponent();
}

// fXgN^
MainForm::~MainForm()
{
    if( components != nullptr )
    {
        delete components;
    }

    delete m_sapi;
}

#pragma region Windows Form Designer generated code
/// <summary>
/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
/// R[h GfB^ŕύXȂłB
/// </summary>
void MainForm::InitializeComponent(void)
{
    this->m_logTextBox = (gcnew System::Windows::Forms::TextBox());
    this->m_recognizedTextBox = (gcnew System::Windows::Forms::TextBox());
    this->m_statusBar = (gcnew System::Windows::Forms::StatusStrip());
    this->m_confidenceStatusLabel = (gcnew System::Windows::Forms::ToolStripStatusLabel());
    this->m_pronunciationStatusLabel = (gcnew System::Windows::Forms::ToolStripStatusLabel());
    this->m_statusStatusLabel = (gcnew System::Windows::Forms::ToolStripStatusLabel());
    this->m_statusBar->SuspendLayout();
    this->SuspendLayout();
    // 
    // m_logTextBox
    // 
    this->m_logTextBox->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
        | System::Windows::Forms::AnchorStyles::Left) 
        | System::Windows::Forms::AnchorStyles::Right));
    this->m_logTextBox->Location = System::Drawing::Point(12, 40);
    this->m_logTextBox->Multiline = true;
    this->m_logTextBox->Name = L"m_logTextBox";
    this->m_logTextBox->ReadOnly = true;
    this->m_logTextBox->ScrollBars = System::Windows::Forms::ScrollBars::Both;
    this->m_logTextBox->Size = System::Drawing::Size(188, 200);
    this->m_logTextBox->TabIndex = 0;
    // 
    // m_recognizedTextBox
    // 
    this->m_recognizedTextBox->Anchor = static_cast<System::Windows::Forms::AnchorStyles>(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Left) 
        | System::Windows::Forms::AnchorStyles::Right));
    this->m_recognizedTextBox->BackColor = System::Drawing::SystemColors::Window;
    this->m_recognizedTextBox->Location = System::Drawing::Point(12, 12);
    this->m_recognizedTextBox->Name = L"m_recognizedTextBox";
    this->m_recognizedTextBox->ReadOnly = true;
    this->m_recognizedTextBox->Size = System::Drawing::Size(188, 19);
    this->m_recognizedTextBox->TabIndex = 2;
    // 
    // m_statusBar
    // 
    this->m_statusBar->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(3) {this->m_confidenceStatusLabel, 
        this->m_pronunciationStatusLabel, this->m_statusStatusLabel});
    this->m_statusBar->Location = System::Drawing::Point(0, 251);
    this->m_statusBar->Name = L"m_statusBar";
    this->m_statusBar->Size = System::Drawing::Size(212, 22);
    this->m_statusBar->TabIndex = 0;
    // 
    // m_confidenceStatusLabel
    // 
    this->m_confidenceStatusLabel->BorderSides = System::Windows::Forms::ToolStripStatusLabelBorderSides::Right;
    this->m_confidenceStatusLabel->Name = L"m_confidenceStatusLabel";
    this->m_confidenceStatusLabel->Size = System::Drawing::Size(45, 17);
    this->m_confidenceStatusLabel->Text = L"Mx";
    // 
    // m_pronunciationStatusLabel
    // 
    this->m_pronunciationStatusLabel->BorderSides = System::Windows::Forms::ToolStripStatusLabelBorderSides::Right;
    this->m_pronunciationStatusLabel->Name = L"m_pronunciationStatusLabel";
    this->m_pronunciationStatusLabel->Size = System::Drawing::Size(102, 17);
    this->m_pronunciationStatusLabel->Spring = true;
    this->m_pronunciationStatusLabel->Text = L"Fꂽ";
    this->m_pronunciationStatusLabel->TextAlign = System::Drawing::ContentAlignment::MiddleLeft;
    // 
    // m_statusStatusLabel
    // 
    this->m_statusStatusLabel->AutoSize = false;
    this->m_statusStatusLabel->Name = L"m_statusStatusLabel";
    this->m_statusStatusLabel->Size = System::Drawing::Size(50, 17);
    this->m_statusStatusLabel->Text = L"F";
    // 
    // MainForm
    // 
    this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
    this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
    this->ClientSize = System::Drawing::Size(212, 273);
    this->Controls->Add(this->m_recognizedTextBox);
    this->Controls->Add(this->m_logTextBox);
    this->Controls->Add(this->m_statusBar);
    this->Name = L"MainForm";
    this->Text = L"MainForm";
    this->m_statusBar->ResumeLayout(false);
    this->m_statusBar->PerformLayout();
    this->ResumeLayout(false);
    this->PerformLayout();

}
#pragma endregion

// tH[\
void MainForm::OnLoad( System::EventArgs^ e )
{
    // {NX̓֐Ăяo
    Windows::Forms::Form::OnLoad( e );


    // SAPI\z
    m_sapi = gcnew SAPI::Recognition();

    // SAPĨAZu擾
    System::Reflection::Assembly^ assembly = System::Reflection::Assembly::GetAssembly( m_sapi->GetType() );

    // ... ̖̂o͂
    Debug::WriteLine( assembly->FullName );


    // ... EBhEnh^SAPI
    if( !m_sapi->Init( this->Handle, L"grammar.xml" ) )
    {
        // ɎsȂ΁AtH[
        this->Close();
    }
}

// WindowsbZ[W
void MainForm::WndProc( Windows::Forms::Message% message )
{
    switch( message.Msg )
    {
        case SAPI::Recognition::REC_EVENT:

            // FCxg
            OnRecognition();
            break;
    }

    // {NX̓֐Ăяo
    Windows::Forms::Form::WndProc( message );
}

// FCxg
void MainForm::OnRecognition()
{
    int eventID;

    // FCxg擾
    while( ( eventID = m_sapi->GetRecognitionEvent() ) != 0 )
    {
        switch( eventID )
        {
            case SAPI::Recognition::SOUND_START:    // Jnꂽ
                break;

            case SAPI::Recognition::SOUND_END:      // Iꂽ
                break;

            case SAPI::Recognition::RECOGNITION:    // Fꂽ
                Recognized();
                break;

            case SAPI::Recognition::FALSE_RECOGNITION:  // FɎs

                // t[Y̏\
                ShowPhraseInfomation();
                break;

            default:
                Debug::Fail( "\ȂCxgԂꂽ" );
        }

        // F̏ԂXe[^Xo[ɕ\
        this->m_statusStatusLabel->Text = m_sapi->GetState( eventID );
    }
}

// Fꂽ
void MainForm::Recognized()
{
    System::String^ text;

    // Fʂ擾
    if( m_sapi->GetRecognitionResult( text ) )
    {
        // eLXg{bNXɕ\
        this->m_recognizedTextBox->Text = text;

        // ... OɒǋL
        this->m_logTextBox->AppendText( text + Environment::NewLine );
    }

    // t[Y̏\
    ShowPhraseInfomation();
}

// t[Y̏\
void MainForm::ShowPhraseInfomation()
{
    double confidence;

    // Mx擾
    if( m_sapi->GetConfidence( confidence ) )
    {
        this->m_confidenceStatusLabel->Text
            = String::Format( "{0,5:####}", Math::Abs( confidence ) );
    }


    System::String^ pronunciation;

    // Fꂽ擾
    if( m_sapi->GetRecognizedPronunciation( pronunciation ) )
    {
        this->m_pronunciationStatusLabel->Text = pronunciation;
    }
}