#pragma once

#include "SpeechEngine.h"

namespace SAPI
{
    class SpeechEngine;

    // F
    public ref class Recognition
    {
    // Construction --------------------------------------------------------
    public:
        ~Recognition() { Recognition::!Recognition(); }
        !Recognition();

    // Operation -----------------------------------------------------------
    public:
        bool Init( System::IntPtr hWnd );
        bool Init( System::IntPtr hWnd, System::String^ grammarFile );

        int GetRecognitionEvent();

        bool GetRecognitionResult( System::String^% text );
        bool GetRecognizedPronunciation( System::String^% text );

        bool GetConfidence( double& value );
        System::String^ GetState( int eventID );

    // Attribute ===========================================================
    private:
        SpeechEngine* m_sapi;

    public:
        literal int REC_EVENT = WM_REC_EVENT;           // FCxg

        literal int SOUND_START = SPEI_SOUND_START;             // Jnꂽ
        literal int SOUND_END = SPEI_SOUND_END;                 // Iꂽ
        literal int RECOGNITION = SPEI_RECOGNITION;             // F
        literal int FALSE_RECOGNITION = SPEI_FALSE_RECOGNITION; // FɎs
    };
}